﻿Imports System.Xml
Imports System.IO
Imports System.Text
Public Class Form1
    Public Sub New()
        InitializeComponent()
        Try
            UploadXML()
        Catch ex As Exception
            If File.Exists(Path) Then
                LoadXML()
            Else
                MsgBox("Загрузить не удалось")
            End If
        End Try
    End Sub
    Dim Path As String = Directory.GetCurrentDirectory & "/Kurs.xml"
    Dim Path_h As String = Directory.GetCurrentDirectory & "/HC.txt"
    Dim xml_file As New XmlDataDocument()
    Dim xmlnode As XmlNodeList
    Private Sub Refreshing(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRefresh.Click
        Try
            UploadXML()
        Catch ex As Exception
            MsgBox("Загрузить не удалось")
        End Try
    End Sub
    Sub UploadXML()
        Dim reader As XmlReader = XmlReader.Create("http://www.cbr.ru/scripts/XML_daily.asp")
        Dim writer As XmlWriter = XmlWriter.Create(Path)
        While reader.Read()
            writer.WriteNode(reader, True)
        End While
        reader.Close()
        writer.Close()
        LoadXML()
    End Sub
    Sub LoadXML()
        Dim sr_file As New StreamReader(Path, Encoding.GetEncoding(1251))
        xml_file.Load(sr_file)
        xmlnode = xml_file.GetElementsByTagName("Valute")
        For i = 0 To xmlnode.Count - 1
            xmlnode(i).ChildNodes.Item(0).InnerText.Trim()
            CLB.Items.Add(xmlnode(i).ChildNodes.Item(3).InnerText.Trim() & " = " & xmlnode(i).ChildNodes.Item(4).InnerText.Trim())
        Next
        Text += " на " & Now.Date
        LoadChecked(False)
    End Sub
    Function LoadChecked(ByVal Bool As Boolean)
        If Bool = True Then
            For Each i As Integer In CLB.CheckedIndices
                List_Checked.Add(i)
            Next
            Dim arr() As String
            ReDim arr(Me.List_Checked.Count - 1)
            List_Checked.CopyTo(arr, 0)
            File.WriteAllLines(Path_h, arr, Encoding.GetEncoding(1251))
        ElseIf File.Exists(Path_h) Then
            Dim arr() As String = File.ReadAllLines(Path_h, Encoding.GetEncoding(1251))
            For i = 0 To arr.Length - 1
                CLB.SetItemChecked(Convert.ToInt16(arr(i)), True)
            Next
        End If
    End Function
    Dim Str As String
    Dim List_Checked As New List(Of String)
    Private Sub NotifyIcon1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Icons.MouseClick
        Str = Nothing
        For Each s As String In CLB.CheckedItems
            Str += s & vbNewLine
        Next
        If Str <> Nothing And e.Button = MouseButtons.Left Then
            Icons.ShowBalloonTip(1000, "Курсы валют", Str, ToolTipIcon.None)
        End If
    End Sub
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        LoadChecked(True)
        Icons.Visible = False
    End Sub
    Private Sub Hiding(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHide.Click
        Me.Hide()
    End Sub
    Private Sub WindowsShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WindowsShow.Click
        Me.Show()
    End Sub
    Private Sub WindowClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WindowClose.Click
        Me.Close()
    End Sub
End Class
